// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package pos

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PosClient is the client API for Pos service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PosClient interface {
	// ListProducts returns a paginated list of all products. See
	// ListProductsRequest for details on filtering.
	ListProducts(ctx context.Context, in *ListProductsRequest, opts ...grpc.CallOption) (*ListProductsResponse, error)
	// CreateOrder tells the backend that the buyer would like to purchase the
	// indicated Products. CreateOrder reserves the items, and is thus not
	// idempotent. The reservations expire after a specified time, after which the
	// Order can no longer be confirmed.
	CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...grpc.CallOption) (*Order, error)
	// ConfirmOrder tells the backend that an order was paid and how the payment
	// was made.
	ConfirmOrder(ctx context.Context, in *ConfirmOrderRequest, opts ...grpc.CallOption) (*OrderConfirmation, error)
	// DeleteOrder cancels an open order. This can return NOT_FOUND if the order
	// is not or no longer known to us. If the services we talk to fail, we return
	// UNAVAILABLE.
	DeleteOrder(ctx context.Context, in *DeleteOrderRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ListCashRegister lists cash registers available to the currently
	// authenticated user. Note that this will return different results based on
	// who is currently authenticated, since not everybody has access to all cash
	// registers.
	ListCashRegister(ctx context.Context, in *ListCashRegisterRequest, opts ...grpc.CallOption) (*ListCashRegisterResponse, error)
	// CreateCashRegister creates a cash register. This should map 1:1 to a
	// physical cash-register. Quästur: Create and Delete Cashregisters
	CreateCashRegister(ctx context.Context, in *CreateCashRegisterRequest, opts ...grpc.CallOption) (*CashRegister, error)
	// DeleteCashRegister deletes a cash register. If the cash register is not
	// empty, this will return an error.
	DeleteCashRegister(ctx context.Context, in *DeleteCashRegisterRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// CreateBooking manually creates a booking to reconcile real world with
	// internal state. This is necessary for corrections (i.e. money in physical
	// cash register differs from our state) and refunds (e.g. expenses).
	CreateBooking(ctx context.Context, in *CreateBookingRequest, opts ...grpc.CallOption) (*Booking, error)
}

type posClient struct {
	cc grpc.ClientConnInterface
}

func NewPosClient(cc grpc.ClientConnInterface) PosClient {
	return &posClient{cc}
}

func (c *posClient) ListProducts(ctx context.Context, in *ListProductsRequest, opts ...grpc.CallOption) (*ListProductsResponse, error) {
	out := new(ListProductsResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/ListProducts", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...grpc.CallOption) (*Order, error) {
	out := new(Order)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/CreateOrder", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) ConfirmOrder(ctx context.Context, in *ConfirmOrderRequest, opts ...grpc.CallOption) (*OrderConfirmation, error) {
	out := new(OrderConfirmation)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/ConfirmOrder", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) DeleteOrder(ctx context.Context, in *DeleteOrderRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/DeleteOrder", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) ListCashRegister(ctx context.Context, in *ListCashRegisterRequest, opts ...grpc.CallOption) (*ListCashRegisterResponse, error) {
	out := new(ListCashRegisterResponse)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/ListCashRegister", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) CreateCashRegister(ctx context.Context, in *CreateCashRegisterRequest, opts ...grpc.CallOption) (*CashRegister, error) {
	out := new(CashRegister)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/CreateCashRegister", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) DeleteCashRegister(ctx context.Context, in *DeleteCashRegisterRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/DeleteCashRegister", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *posClient) CreateBooking(ctx context.Context, in *CreateBookingRequest, opts ...grpc.CallOption) (*Booking, error) {
	out := new(Booking)
	err := c.cc.Invoke(ctx, "/vseth.vis.pos.Pos/CreateBooking", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PosServer is the server API for Pos service.
// All implementations must embed UnimplementedPosServer
// for forward compatibility
type PosServer interface {
	// ListProducts returns a paginated list of all products. See
	// ListProductsRequest for details on filtering.
	ListProducts(context.Context, *ListProductsRequest) (*ListProductsResponse, error)
	// CreateOrder tells the backend that the buyer would like to purchase the
	// indicated Products. CreateOrder reserves the items, and is thus not
	// idempotent. The reservations expire after a specified time, after which the
	// Order can no longer be confirmed.
	CreateOrder(context.Context, *CreateOrderRequest) (*Order, error)
	// ConfirmOrder tells the backend that an order was paid and how the payment
	// was made.
	ConfirmOrder(context.Context, *ConfirmOrderRequest) (*OrderConfirmation, error)
	// DeleteOrder cancels an open order. This can return NOT_FOUND if the order
	// is not or no longer known to us. If the services we talk to fail, we return
	// UNAVAILABLE.
	DeleteOrder(context.Context, *DeleteOrderRequest) (*emptypb.Empty, error)
	// ListCashRegister lists cash registers available to the currently
	// authenticated user. Note that this will return different results based on
	// who is currently authenticated, since not everybody has access to all cash
	// registers.
	ListCashRegister(context.Context, *ListCashRegisterRequest) (*ListCashRegisterResponse, error)
	// CreateCashRegister creates a cash register. This should map 1:1 to a
	// physical cash-register. Quästur: Create and Delete Cashregisters
	CreateCashRegister(context.Context, *CreateCashRegisterRequest) (*CashRegister, error)
	// DeleteCashRegister deletes a cash register. If the cash register is not
	// empty, this will return an error.
	DeleteCashRegister(context.Context, *DeleteCashRegisterRequest) (*emptypb.Empty, error)
	// CreateBooking manually creates a booking to reconcile real world with
	// internal state. This is necessary for corrections (i.e. money in physical
	// cash register differs from our state) and refunds (e.g. expenses).
	CreateBooking(context.Context, *CreateBookingRequest) (*Booking, error)
	mustEmbedUnimplementedPosServer()
}

// UnimplementedPosServer must be embedded to have forward compatible implementations.
type UnimplementedPosServer struct {
}

func (UnimplementedPosServer) ListProducts(context.Context, *ListProductsRequest) (*ListProductsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListProducts not implemented")
}
func (UnimplementedPosServer) CreateOrder(context.Context, *CreateOrderRequest) (*Order, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateOrder not implemented")
}
func (UnimplementedPosServer) ConfirmOrder(context.Context, *ConfirmOrderRequest) (*OrderConfirmation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ConfirmOrder not implemented")
}
func (UnimplementedPosServer) DeleteOrder(context.Context, *DeleteOrderRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteOrder not implemented")
}
func (UnimplementedPosServer) ListCashRegister(context.Context, *ListCashRegisterRequest) (*ListCashRegisterResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListCashRegister not implemented")
}
func (UnimplementedPosServer) CreateCashRegister(context.Context, *CreateCashRegisterRequest) (*CashRegister, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateCashRegister not implemented")
}
func (UnimplementedPosServer) DeleteCashRegister(context.Context, *DeleteCashRegisterRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteCashRegister not implemented")
}
func (UnimplementedPosServer) CreateBooking(context.Context, *CreateBookingRequest) (*Booking, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateBooking not implemented")
}
func (UnimplementedPosServer) mustEmbedUnimplementedPosServer() {}

// UnsafePosServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PosServer will
// result in compilation errors.
type UnsafePosServer interface {
	mustEmbedUnimplementedPosServer()
}

func RegisterPosServer(s grpc.ServiceRegistrar, srv PosServer) {
	s.RegisterService(&Pos_ServiceDesc, srv)
}

func _Pos_ListProducts_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListProductsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).ListProducts(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/ListProducts",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).ListProducts(ctx, req.(*ListProductsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_CreateOrder_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateOrderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).CreateOrder(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/CreateOrder",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).CreateOrder(ctx, req.(*CreateOrderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_ConfirmOrder_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfirmOrderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).ConfirmOrder(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/ConfirmOrder",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).ConfirmOrder(ctx, req.(*ConfirmOrderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_DeleteOrder_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteOrderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).DeleteOrder(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/DeleteOrder",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).DeleteOrder(ctx, req.(*DeleteOrderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_ListCashRegister_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListCashRegisterRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).ListCashRegister(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/ListCashRegister",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).ListCashRegister(ctx, req.(*ListCashRegisterRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_CreateCashRegister_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateCashRegisterRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).CreateCashRegister(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/CreateCashRegister",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).CreateCashRegister(ctx, req.(*CreateCashRegisterRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_DeleteCashRegister_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteCashRegisterRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).DeleteCashRegister(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/DeleteCashRegister",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).DeleteCashRegister(ctx, req.(*DeleteCashRegisterRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Pos_CreateBooking_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateBookingRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PosServer).CreateBooking(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.pos.Pos/CreateBooking",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PosServer).CreateBooking(ctx, req.(*CreateBookingRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Pos_ServiceDesc is the grpc.ServiceDesc for Pos service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Pos_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.pos.Pos",
	HandlerType: (*PosServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListProducts",
			Handler:    _Pos_ListProducts_Handler,
		},
		{
			MethodName: "CreateOrder",
			Handler:    _Pos_CreateOrder_Handler,
		},
		{
			MethodName: "ConfirmOrder",
			Handler:    _Pos_ConfirmOrder_Handler,
		},
		{
			MethodName: "DeleteOrder",
			Handler:    _Pos_DeleteOrder_Handler,
		},
		{
			MethodName: "ListCashRegister",
			Handler:    _Pos_ListCashRegister_Handler,
		},
		{
			MethodName: "CreateCashRegister",
			Handler:    _Pos_CreateCashRegister_Handler,
		},
		{
			MethodName: "DeleteCashRegister",
			Handler:    _Pos_DeleteCashRegister_Handler,
		},
		{
			MethodName: "CreateBooking",
			Handler:    _Pos_CreateBooking_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/vis/pos/pos.proto",
}
